/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.impl.database;

import database.connection.ConnectionFactory;
import domain.Product;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import storage.StorageProduct;

/**
 *
 * @author student1
 */
public class StorageDatabaseProduct implements StorageProduct {

    @Override
    public Product save(Product product) throws Exception {
        Connection connection = ConnectionFactory.getInstance().getConnection();
        String query = "INSERT INTO product (name,description,id_manufacturer,price,measurement_unit) VALUES(?,?,?,?,?)";

        PreparedStatement preparedStatement = connection.prepareStatement(query, Statement.RETURN_GENERATED_KEYS);
        preparedStatement.setString(1, product.getName());
        preparedStatement.setString(2, product.getDescription());
        preparedStatement.setLong(3, product.getManufacturer().getId());
        preparedStatement.setBigDecimal(4, product.getPrice());
        preparedStatement.setString(5, String.valueOf(product.getMeasurementUnit()));
        preparedStatement.executeUpdate();

        // uzmi generisan id:
        ResultSet rs = preparedStatement.getGeneratedKeys();
        if (rs.next()) {
            Long id = rs.getLong(1);
            product.setId(id);
        } // else { kljuc nije generisan  }
        preparedStatement.close();
        return product;
    }

}
